/*
Firmware to detect shadows on a line-CCD from an Epson SX125
(C) 2011 Jeroen Domburg (jeroen AT spritesmods.com)

This program is free software: you can redistribute it and/or modify
t under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
	    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
			    
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <stdio.h>
#include <avr/io.h>
#include <avr/sleep.h>
#include <avr/interrupt.h>

#ifndef UCSR0A
#define UCSR0A UCSRA
#define UCSR0B UCSRB
#define UDR0 UDR
#define UBRR0H UBRRH
#define UBRR0L UBRRL
#endif

static int uart_putchar(char c, FILE *stream) {
    if (c=='\n') uart_putchar('\r', stream);
    while(!(UCSR0A&0x20)) ;
    UDR0=c;
    return 0;
}

static FILE mystdout = FDEV_SETUP_STREAM(uart_putchar, NULL, _FDEV_SETUP_WRITE);

void stdoutInit(int ubr) {
    UCSR0B=0x18;
    UBRR0L=ubr&0xff;
    UBRR0H=ubr>>8;
    stdout = &mystdout;
}
