/*
Software to convert a line-CCD plus a bunch of LEDs to a touchscreen.
(C) 2011 Jeroen Domburg (jeroen AT spritesmods.com)

This program is free software: you can redistribute it and/or modify
t under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
	    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
			    
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <SDL/SDL.h>
#include <cairo/cairo.h>

SDL_Surface *sdlScreen;
SDL_Surface *cairoSdlSurf;
cairo_surface_t *cairoSurf;

static SDL_Surface *initScreen(int opts, int w, int h) {
	SDL_Surface *screen;
	if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_JOYSTICK)<0) {
		fprintf(stderr,"Couldn't init SDL!");
		exit(1);
	}
	atexit(SDL_Quit);

	SDL_WM_SetCaption("test","test");
	screen=SDL_SetVideoMode(w,h,32,SDL_DOUBLEBUF|SDL_HWSURFACE|opts);
	if (screen == NULL) {
		fprintf(stderr,"Couldn't create surface! %s\n",SDL_GetError());
		exit(1);
	}
//	SDL_WarpMouse(size.x,size.y);
	return screen;
}

static SDL_Rect mkrect(int x,int y,int w,int h) {
    SDL_Rect tmp;
    tmp.x=x; tmp.y=y; tmp.w=w; tmp.h=h;
    return tmp;
}


void cairoSdlBlit(cairo_t *cr) {
	SDL_Rect rfrom=mkrect(0,0,cairoSdlSurf->w, cairoSdlSurf->h);
	SDL_Rect rto=mkrect(0,0,sdlScreen->w, sdlScreen->h);
	SDL_BlitSurface(cairoSdlSurf, &rfrom, sdlScreen, &rto);
	SDL_Flip(sdlScreen);
}


cairo_t *cairoSdlInit(int w, int h) {
	cairo_t *cr;

	sdlScreen=initScreen(0, w, h);//	SDL_FULLSCREEN;
	cairoSdlSurf=SDL_CreateRGBSurface(0, w, h, 32, 0xff0000, 0xff00, 0xff, 0);
	cairoSurf=cairo_image_surface_create_for_data(cairoSdlSurf->pixels, 
		CAIRO_FORMAT_RGB24, cairoSdlSurf->w, cairoSdlSurf->h, cairoSdlSurf->pitch);
	cr=cairo_create(cairoSurf);
	return cr;
}
