/*
Software to convert a line-CCD plus a bunch of LEDs to a touchscreen.
(C) 2011 Jeroen Domburg (jeroen AT spritesmods.com)

This program is free software: you can redistribute it and/or modify
t under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
	    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
			    
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <SDL/SDL.h>
#include <cairo/cairo.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "serial.h"
#include "cairosdl.h"
#include "calibrate.h"
#include "misc.h"

int main(int argc, char** argv) {
	int fd;
	int no,x;
	BlackMark meas[100];
	touchedPointStruct points[100];
	cairo_t *cr=cairoSdlInit(1024,786);
	
	if (argc==1) {
		fd=serialOpen("/dev/ttyUSB0");
	} else {
		fd=serialOpen(argv[1]);
	}

	calibrate(fd, cr);

	while(1) {
		no=serialRead(fd, meas, 100);
		cairo_set_source_rgb(cr, 255,255,255);
		cairo_paint(cr);
		drawMeasLines(cr, meas, no);
		no=getCoords(meas, no, points);
		for (x=0; x<no; x++) {
			if (points[x].confidence>0) {
				cairo_set_line_width(cr, points[x].confidence);
				cairo_set_source_rgb(cr, 0,0,0);
				cairo_arc(cr, points[x].x, points[x].y, points[x].size*.5, 0, 2*M_PI);
				cairo_stroke(cr);
			} else {
				cairo_set_line_width(cr, 1);
				if (points[x].confidence==CONFIDENCE_DUPLICATE) cairo_set_source_rgb(cr, 0,1,0);
				if (points[x].confidence==CONFIDENCE_GHOST) cairo_set_source_rgb(cr, 1,0,0);
				if (points[x].confidence==CONFIDENCE_UNLIKELY) cairo_set_source_rgb(cr, 0,0,1);
				cairo_arc(cr, points[x].x, points[x].y, 5, 0, 2*M_PI);
				cairo_fill(cr);
			}
		}
		cairoSdlBlit(cr);
	}
}
