/*
Software to convert a line-CCD plus a bunch of LEDs to a touchscreen.
(C) 2011 Jeroen Domburg (jeroen AT spritesmods.com)

This program is free software: you can redistribute it and/or modify
t under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
	    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
			    
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "misc.h"

void drawMeasLines(cairo_t *cr, BlackMark *meas, int no) {
	int x;
	cairo_set_line_width(cr, 1);
	cairo_set_source_rgb(cr, .5, .5, .5);

	for (x=0; x<8; x++) {
		cairo_move_to(cr, 0, x*20+20);
		cairo_line_to(cr, 1024, x*20+20);
		cairo_stroke(cr);
	}

	cairo_set_source_rgb(cr, 0,0,0);
	for (x=0; x<no; x++) {
		cairo_move_to(cr, meas[x].start/3, meas[x].led*20+20+x);
		cairo_line_to(cr, (meas[x].start+meas[x].len)/3, meas[x].led*20+20+x);
		cairo_stroke(cr);
	}
}

